<template lang="pug">
  .item-state
    div(v-if="record")
      .pa3.bg-white
        h1.tc
          strong {{titleZh[0]}}&nbsp;
          | 的&nbsp;
          strong {{titleZh[1]}}問題&nbsp;
          | /&nbsp;
          strong {{titleEn[1]}} Issue&nbsp;
          | in&nbsp;
          strong {{titleEn[0]}}
      .pa4(v-if="record")
        .item-state__wrapper.mw6.center
          .bl.b--gray.ph3.pb3.relative
            .item-state__onestate.mv4(
              v-for="(stateInfo, index) in logByStates"
              :key="stateInfo.id"
              :ref="stateInfo.id"
            )
              .item-state__title.br-pill.relative.ph4.pv2.mv3.white.flex.justify-between.items-center
                .f4 {{stateInfo.name}}
                .f5 {{timeStr(stateInfo.time)}}
              .item-state__chatlog(
                v-for="log in stateInfo.logs"
                :key="log.time"
              ) {{log.msg}}
            .item-state__end.w2.h2.bg-white.ba.br-100.absolute
    b-loading(:active="onInit")
</template>
<script>
import moment from 'moment'
import { issue } from '~/utils/api'
import { issueMixin } from '~/utils/mixins'
import ExternalLink from '~/components/ExternalLink'
import ChatLog from '~/components/ChatLog'

const SCROLL_PADDING = 20
const LOADING_ANI_TIME = 1500

export default {
  components: {
    ExternalLink,
    ChatLog
  },
  layout: 'public',
  mixins: [issueMixin],
  data () {
    return {
      record: null,
      onInit: true
    }
  },
  computed: {
    recordId () {
      return this.$route.params.recordId.replace(/[^a-zA-Z0-9.-_]/g, '')
    },
    titleZh () {
      const house = `${this.zh(this.record.buildingId)} ${this.record.roomId}`
      const type = this.zh(this.record.taskType)
      return [house, type]
    },
    titleEn () {
      const house = `${this.en(this.record.buildingId)} ${this.record.roomId}`
      const type = this.en(this.record.taskType)
      return [house, type]
    },
    logByStates () {
      const stateList = []
      const logs = this.record.publicHistory
      if (logs.length === 0) {
        return []
      }
      let curState = {
        id: 'state-0',
        name: '通報完成 Issue Submitted',
        time: moment(logs[0].reportedAt),
        logs: []
      }
      logs.forEach((log) => {
        if (log.state !== curState.name) {
          stateList.push(curState)
          curState = {
            id: `state-${stateList.length}`,
            name: log.state,
            time: moment(log.createdAt),
            logs: [log]
          }
        } else {
          curState.logs.push(log)
        }
      })
      stateList.push(curState)
      return stateList
    }
  },
  async created () {
    this.record = await issue.getReport(this.recordId)
    this.onInit = false
    this.toFinalState()
  },
  methods: {
    timeStr (time) {
      return time.format('YYYY/MM/DD HH:mm')
    },
    toFinalState () {
      setTimeout(() => {
        const lastState = this.logByStates[this.logByStates.length - 1]
        if (!lastState) {
          return
        }
        const lastStateRef = this.$refs[lastState.id]
        if (lastStateRef && lastStateRef.length) {
          window.scrollTo({
            top: lastStateRef[0].offsetTop - SCROLL_PADDING,
            behavior: 'smooth'
          })
        }
      }, LOADING_ANI_TIME)
    }
  }
}
</script>
<style lang="scss" scoped>
$title-padding: 3em;

.item-state {
  &__subscribe.button {
    height: 4em;

    /deep/ > span {
      padding: 0 1.25em;
    }
  }
  &__wrapper {
    padding: 0 $title-padding;
  }
  &__onestate {
    &:first-child {
      margin-top: 0;
    }
  }
  &__title {
    left: -$title-padding;
    background: #c1d045;
    width: calc(100% + #{$title-padding} * 2);
  }
  &__chatlog /deep/ {
    .mw-70 {
      max-width: 100%;
      width: 100%;
      background: transparent;
    }
  }
  &__end {
    left: -1em;
  }
}
</style>
